#### Description:

This macro invokes a function to begin a new AST context. Any Object pointers created within this context will be annulled when it is later ended using astEnd (just as if astAnnul had been invoked), unless they have first been exported using astExport or rendered exempt using astExempt. If annulling a pointer causes an Object`’` s RefCount attribute to fall to zero (which happens when the last pointer to it is annulled), then the Object will be deleted.

#### Synopsis

void astBegin

#### Applicability

##### Object

This macro applies to all Objects.

#### Notes:

- astBegin attempts to execute even if the AST error status is set on entry.

- Contexts delimited by astBegin and astEnd may be nested to any depth.

Copyright (C) 2021 East Asian Observatory